//#declare nucleus_test=1;

#ifdef (nucleus_test)
 #include "colors.inc"
 #include "eye_macro.inc"
 #include "blob_macro.inc"
 #include "spline.inc"
 #include "dna.inc" 
 #include "eye.inc"
#end

#declare mouth_tmp=
blob{
  threshold blob_threshold
  sphere{0 bp(1,1.9) scale <0.6,0.34,0.34> rotate z*10 translate <.3,1.02,0>}
  sphere{0 bp(1,1.9) scale <0.7,0.34,0.34> rotate z*-30 translate <1.1,0.9,0>}
  sphere{0 bp(.1,1) scale 0.2 translate<1.8,0.55,0> }
}

                                           
#declare Mouth=union{
  blob{
    threshold blob_threshold
    sphere{0 bp(1,1.7) scale <1,0.38,0.38>}
    sphere{0 bp(1,1.5) scale <0.8,0.3,0.3> rotate z*20 translate <1,0.3,0> }
    sphere{0 bp(1,1.5) scale <0.8,0.3,0.3> rotate z*-20 translate <-1,0.3,0>}
    sphere{0 bp(.1,1) scale 0.2 translate<1.8,0.55,0> }
    sphere{0 bp(.1,1) scale 0.2 translate<-1.8,0.55,0> }
  }
 
  object{mouth_tmp}
  object{mouth_tmp
 scale -1
 rotate x*180
 }
}

#declare Body=
lathe{
 bezier_spline
 4,
 <0,1>
 <.8,1>
 <1.8,-1>
 <0,-1>
 scale 1.5*<1.3,1,1.3>
}



#declare sib=seed(1);

#macro inside_body(siz)
  sphere{ 0, 1 scale siz*(0.6+rand(sib))
    pigment{color rgb <rand(sib),rand(sib),rand(sib)>}}
    finish{ambient 1}
  }  
#end

#macro Nucleus(lid,lcount,eyecolor)
union{
  object{Body 
    pigment{color Black transmit 0.7}
    finish{ 
      specular 0.2
      roughness 0.01
    }
  }
   
  
//  difference{              // zakomentovat pre zrychlenie 
//    union{                 // zakomentovat pre zrychlenie 
      object{Mouth scale 0.4 translate <-0,-0.76,-1.9> 
        pigment{color Red}
        finish{phong 0.2 phong_size 1}
      }
      object{Eye(lid,lcount,eyecolor,10,color Flesh) rotate x*30 translate <0.27,.35,-1.5>}
      object{Eye(lid,lcount,eyecolor,10,color Flesh) rotate x*30 scale -1 rotate x*180 translate <-0.27,.35,-1.5>}
//    }                      // zakomentovat pre zrychlenie 
//    object{Body }          //zakomentovat pre zrychlenie 
//  }                        // zakomentovat pre zrychlenie 
/*
  layout{
    object{Body}
    layout_inside    
    layout_count 30
    layout_size 0.04
    layout_distance 0.05
    "inside_body"
  }    */
  object{Dna() scale 0.8 rotate x*30 translate <0.6,0.3,-0.3>}
//  object{Dna() rotate <90,0,0> translate <0.4,0.1,0>}
  #declare i=1; #while(i<0)
    light_source{ <rand(sib),rand(sib),rand(sib)> 
      color rgb 0.4*<rand(sib),rand(sib),rand(sib)>
      fade_power 14
      fade_distance .4
    }  
    #declare i=i+1;
  #end
  light_source{-4*z color Gray90 shadowless fade_power 14 fade_distance .6}
}
#end

#ifdef (nucleus_test)
//TEST                       
#background{White}             
#camera{
  location <0,0,-7>
  look_at <0,0,0>
  orthographic
}

#light_source{ <1,1,-10> color rgb 1}

#object{Nucleus(0.1,3,Cyan) rotate y*90  translate x*2}
#object{Nucleus(-0.1,3,Green)  translate x*-2 }

#end