#macro Spline(N,A,w)
  #local V=array[2][N]
  #local act=1;
  #local i=0;#while(i<N)
    #local V[0][i]=A[i];
    #local i=i+1;
  #end
  #local rr=1;#while (rr<N)
    #local i=0;#while(i<N-rr)
      #local V[act][i]=(1-w)*V[1-act][i]+w*V[1-act][i+1];
      #local i=i+1;
    #end
    #local rr=rr+1;
    #local act=1-act;
  #end      
  V[1-act][0]    
#end

#macro SplineNormal(N,A,w)
  #local V=array[2][N]
  #local act=1;
  #local i=0;#while(i<N-1)
    #if (i=0) #local splinetmp=A[2];#else#local splinetmp=A[i-1];#end
    #local q=vdot(A[i+1]-A[i],A[i+1]-splinetmp);
    #local V[0][i]=vnormalize(-q/vdot(A[i+1]-A[i],A[i+1]-A[i])*(A[i+1]-A[i])+A[i+1]-splinetmp);
    #local i=i+1;
  #end

//V[0][0]*(1-w)+w*V[0][1]

  #local rr=2;#while (rr<N)
    #local i=0;#while(i<N-rr)
      #local V[act][i]=vnormalize((1-w)*V[1-act][i]+w*V[1-act][i+1]);
      #local i=i+1;
    #end
    #local rr=rr+1;
    #local act=1-act;
  #end      
  V[1-act][0]    
#end



/*
// TEST
#include "colors.inc"
#camera{
  location <0,0,-5>
  look_at 0
  orthographic
}

light_source{ <10,10,-30 > color White}
background{White}

#declare N=3;
#declare A=array[3]{-x,1*y+x,x}

#declare i=0;#while(i<N)
  sphere{A[i], 0.1 pigment{color Green}}
  #declare i=i+1;
#end
  
#declare i=0;#while (i<=1)
  sphere{0 0.05 pigment{color Red}
     translate Spline(N,A,i)
  }
  #declare i=i+0.01;
#end     

#declare i=0;#while (i<=1)
  cylinder{ 0, SplineNormal(N,A,i) , 0.02 
    translate Spline(N,A,i)
    pigment{color Blue}
  }
  #declare i=i+0.1;
#end


 */